{KABOOM FOR HYBRID}
CON
  ' Set up the processor clock in the standard way for 96MHz on HYBRID
_CLKMODE = xtal1 + pll16x
_XINFREQ = 6_000_000 + 0000

VAR
  byte                displayb[20]                  'allocate display buffer in RAM
                                                    'for now, just one line of char mode GFX.
                                                    'might do two, for logo at bottom

  long                render_tab[200]         '190 longs to hold sprite render list

  long                sprite0[400]    'sprite 0 graphic data
  long                sprite1[400]    'sprite 1 graphic data          


  long                index            'just an index...

  long                params[7]                               'The address of this array gets 
                                                             'passed to TV driver.                   
  
OBJ
  tv : "KABOOM_TV_18"         'the actual TV display driver
  
PUB start |  c, o, d, p

' Communication between video COG and the game COG

    params[0] := @displayb      'display buffer for char mode score
    params[1] := @fonttab       'chars for score
    params[2] := @render_tab    'display list handling background color, sprites x positions
    params[3] := $0008e03       'char mode colors, light yellow on grey  this is the score color
    params[4] := @sprite0       'sprite strip 0 graphics data
    params[5] := @sprite1       'sprite strip 1 graphics data
    params[6] := 0              'vblank flag, for display sync.


'Start Screen driver & get stuff setup to display game screen
    screen_init
 



'test move the bomber to see if display is frame locked
    repeat
       repeat c from 0 to 300
         wait_for_vblank
         bomber_position(c / 2)
      


    


PRI  screen_init
      sprite_init   
      render_tab_init    
      paddle_init
      score_init
      bomber_init(@bomber_body_happy)
      bomber_position(100)     
      tv.start(@params)    'start the tv cog & pass it the parameter block 

PRI  bomber_position(bomberx)
     sprite1_xpos(0, 35, bomberx)
     

PRI  sprite0_xpos(start_scan, scan_num, sprite0_x)
     repeat index from start_scan * 4 to (start_scan * 4) + (scan_num * 4) step 4
       byte [@render_tab] [index + 1] := sprite0_x

PRI  sprite1_xpos(start_scan, scan_num, sprite1_x)
     repeat index from start_scan * 4 to (start_scan * 4) + (scan_num * 4) step 4
       byte [@render_tab] [index + 2] := sprite1_x 


PRI  bomber_init(bomber_graphics)
     longmove (@sprite1, bomber_graphics, 70)


PRI  score_init
'char mode (score) test code
  repeat index from 0 to 19 step 1
     byte [@displayb] [index] := $a      
  byte [@displayb] [index - 10] := 0     


PRI  score_inc(value)
     'gonna just add to the score here


PRI  wait_for_vblank
     repeat until params[6] == 1
     'long  [@displayb] [0] := params[6]  'To debug VBLANK

PRI  render_tab_init
'Build Render Table
    repeat index from 0 to 189 * 4 step 4
      byte [@render_tab] [index] := 0           'set background color
      byte [@render_tab] [index + 1] := $20       'set sprite 0 x pos
      byte [@render_tab] [index + 2] := $28       'set sprite 1 x pos
      byte [@render_tab] [index + 3] := $00       'double sprite 0, if > 0

    repeat index from 0 to 31 * 4 step 4
      byte [@render_tab] [index] := 1           'set background color to light grey



    'repeat index from 54 * 4 to 68 * 4 step 4
    '  byte [@render_tab] [index + 3] := 1              'set sprite0 doubling flag


PRI  paddle_init
'Fill sprites with test paddle on screen

    repeat index from (17 * 64) to (21 * 64) step 128
       longmove (@sprite0 + index, @paddle_left, 16)
       longmove (@sprite1 + index, @paddle_right, 16)


PRI  sprite_init
'Fill sprites with some color
   longfill (@sprite0, $0, 400)
   longfill (@sprite1, $0, 400)

'Fill Sprites with test data ---some bombs and fuses on screen   
    repeat index from (5 * 64) to (14 * 64) step 128
       longmove (@sprite1 + index, @bomb_fuse_1, 30)



DAT
              'font table for score in char mode

fonttab    byte byte %00000000   '0'       
           byte byte %00111100             
           byte byte %01100110             
           byte byte %01110110             
           byte byte %01101110             
           byte byte %01100110             
           byte byte %00111100             
           byte byte %00000000             
                       
           byte byte %00000000   '1'       
           byte byte %00011000             
           byte byte %00011100             
           byte byte %00011000             
           byte byte %00011000             
           byte byte %00011000             
           byte byte %01111110             
           byte byte %00000000             
                       
           byte byte %00000000   '2'       
           byte byte %00111100             
           byte byte %01100110             
           byte byte %00110000             
           byte byte %00011000             
           byte byte %00001100             
           byte byte %01111110             
           byte byte %00000000             
                       
           byte byte %00000000   '3'       
           byte byte %01111110             
           byte byte %00110000             
           byte byte %00011000             
           byte byte %00110000             
           byte byte %01100110             
           byte byte %00111100             
           byte byte %00000000             
                       
           byte byte %00000000   '4'       
           byte byte %00110000             
           byte byte %00111000             
           byte byte %00111100             
           byte byte %00110110             
           byte byte %01111110             
           byte byte %00110000             
           byte byte %00000000             
                       
           byte byte %00000000   '5'       
           byte byte %01111110             
           byte byte %00000110             
           byte byte %00111110             
           byte byte %01100000             
           byte byte %01100110             
           byte byte %00111100             
           byte byte %00000000             
                       
           byte byte %00000000   '6'       
           byte byte %00111100             
           byte byte %00000110             
           byte byte %00111110             
           byte byte %01100110             
           byte byte %01100110             
           byte byte %00111100             
           byte byte %00000000             
                       
           byte byte %00000000   '7'       
           byte byte %01111110             
           byte byte %01100000             
           byte byte %00110000             
           byte byte %00011000             
           byte byte %00001100             
           byte byte %00001100             
           byte byte %00000000             
                       
           byte byte %00000000   '8'       
           byte byte %00111100             
           byte byte %01100110             
           byte byte %00111100             
           byte byte %01100110             
           byte byte %01100110             
           byte byte %00111100             
           byte byte %00000000             
                       
           byte byte %00000000   '9'       
           byte byte %00111100             
           byte byte %01100110             
           byte byte %01111100             
           byte byte %01100000             
           byte byte %00110000             
           byte byte %00011100             
           byte byte %00000000             

           byte byte %00000000   'A'' '       
           byte byte %00000000             
           byte byte %00000000             
           byte byte %00000000             
           byte byte %00000000             
           byte byte %00000000             
           byte byte %00000000             
           byte byte %00000000      
DAT

bomb_fuse_1
           long  $0000001e, $00000000       'use hi-sat colors for flame!
           long  $0000002e, $2e000000
           long  $00000000, $3e000000
           long  $00000000, $05000000
           long  $00000004, $00000000
           long  $00000400, $00000000
           long  $00000004, $00000000

bomb_base  long  $00000003, $00000000
           long  $00000404, $04000000
           long  $00050505, $05050000
           long  $00070707, $07070000
           long  $00050505, $05050000
           long  $00000404, $04000000
           long  $00000003, $00000000




bomber_body_sad     long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00007a7a, $7a000000
                    long  $007c7c7c, $7c7c0000
                    long  $007d7d7d, $7d7d0000
                    long  $00020202, $02020000
                    long  $02020002, $00020200
                    long  $02020202, $02020200
                    long  $5b5b5b00, $5b5b5b00
                    long  $005b5b00, $5b5b0000
                    long  $005d5d5d, $5d5d0000
                    long  $005d5d00, $5d5d0000
                    long  $005d005d, $005d0000
                    long  $00005d5d, $5d000000
                    long  $00005b5b, $5b000000
                    long  $00000202, $02000000
                    long  $00060606, $06060000
                    long  $02020202, $02020200
                    long  $06060606, $06060600
                    long  $02020202, $02020200
                    long  $06060606, $06060600
                    long  $02020202, $02020200
                    long  $06020606, $06020600  'a
                    long  $02020302, $03020200  'b
                    long  $06020606, $06020600  'a
                    long  $02020302, $03020200  'b
                    long  $06020606, $06020600  'a
                    long  $02020302, $03020200  'b
                    long  $06020606, $06020600  'a
                    long  $5d000000, $00005d00
                    long  $5d000000, $00005d00
                    long  $005d0000, $005d0000

bomber_body_happy   long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00000000, $00000000
                    long  $00007a7a, $7a000000
                    long  $007c7c7c, $7c7c0000
                    long  $007d7d7d, $7d7d0000
                    long  $00020202, $02020000
                    long  $02020002, $00020200
                    long  $02020202, $02020200
                    long  $5b5b5b00, $5b5b5b00
                    long  $005b5b00, $5b5b0000
                    long  $005d5d5d, $5d5d0000
                    long  $005d005d, $005d0000
                    long  $005d5d00, $5d5d0000
                    long  $00005d5d, $5d000000
                    long  $00005b5b, $5b000000
                    long  $00000202, $02000000
                    long  $00060606, $06060000
                    long  $02020202, $02020200
                    long  $06060606, $06060600
                    long  $02020202, $02020200
                    long  $06060606, $06060600
                    long  $02020202, $02020200
                    long  $06020606, $06020600  'a
                    long  $02020302, $03020200  'b
                    long  $06020606, $06020600  'a
                    long  $02020302, $03020200  'b
                    long  $06020606, $06020600  'a
                    long  $02020302, $03020200  'b
                    long  $06020606, $06020600  'a
                    long  $5d000000, $00005d00
                    long  $5d000000, $00005d00
                    long  $005d0000, $005d0000





paddle_left         long  $8c8c8c8c, $8c8c0000
                    long  $00000000, $00000000
                    long  $00007d7d, $00007d7d
                    long  $00007d7d, $00007d7d
                    long  $00007c7c, $00007c7c
                    long  $00007c7c, $00007c7c
                    long  $00007b7b, $00007b7b
                    long  $7b7b7b7b, $7b7b7b7b


                    

paddle_right        long  $00000000, $8c8c8c8c
                    long  $00000000, $00000000
                    long  $00007d7d, $00007d7d
                    long  $00007d7d, $00007d7d
                    long  $00007c7c, $00007c7c
                    long  $00007c7c, $00007c7c
                    long  $00007b7b, $00007b7b
                    long  $00007b7b, $7b7b7b7b